<?php

//
// Start mod
//
if(!defined('IN_PHPBB'))
{
	define('IN_PHPBB', 1);
	$phpbb_root_path = "./../";
	require($phpbb_root_path . 'extension.inc');
	require('./pagestart.' . $phpEx);
}
else
{
	if( !empty($setmodules) )
	{
		$file = basename(__FILE__);
		$module['Extreme_Styles']['Styles'] = $file;
	}
}

//
// include language file
//

if(!defined('XS_LANG_INCLUDED'))
{
	$xs_lang_file = $phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_xs.'.$phpEx;
	if( !@file_exists($xs_lang_file) )
	{	// load english version if there is no translation to current language
		$xs_lang_file = $phpbb_root_path . 'language/lang_english/lang_xs.'.$phpEx;
	}
	@include($xs_lang_file);
	define('XS_LANG_INCLUDED', true);
}

//
// exit if mod was called just to set modules
//

if( !empty($setmodules) )
{
	return;
}

//
// set new default style
//
if(!empty($HTTP_GET_VARS['setdefault']))
{
	$board_config['default_style'] = intval($HTTP_GET_VARS['setdefault']);
	$sql = "UPDATE " . CONFIG_TABLE . " SET config_value='" . $board_config['default_style'] . "' WHERE config_name='default_style'";
	$db->sql_query($sql);
}

//
// change "override" variable
//
if(isset($HTTP_GET_VARS['setoverride']))
{
	$board_config['override_user_style'] = intval($HTTP_GET_VARS['setoverride']);
	$sql = "UPDATE " . CONFIG_TABLE . " SET config_value='" . $board_config['override_user_style'] . "' WHERE config_name='override_user_style'";
	$db->sql_query($sql);
}

//
// move all users to some style
//
if(!empty($HTTP_GET_VARS['moveusers']))
{
	$id = intval($HTTP_GET_VARS['moveusers']);
	$sql = "UPDATE " . USERS_TABLE . " SET user_style='" . $id . "' WHERE user_id > 0";
	$db->sql_query($sql);
}

//
// move all users from some style
//
if(!empty($HTTP_GET_VARS['moveaway']))
{
	$id = intval($HTTP_GET_VARS['moveaway']);
	$id2 = intval($HTTP_GET_VARS['style']);
	if($id2)
	{
		$sql = "UPDATE " . USERS_TABLE . " SET user_style='" . $id2 . "' WHERE user_id > 0 AND user_style = " . $id;
	}
	else
	{
		$sql = "UPDATE " . USERS_TABLE . " SET user_style = NULL WHERE user_id > 0 AND user_style = " . $id;
	}
	$db->sql_query($sql);
}

//
// get list of installed styles
//

$sql = 'SELECT themes_id, template_name, style_name FROM ' . THEMES_TABLE . ' ORDER BY template_name';
if(!$result = $db->sql_query($sql))
{
	message_die(GENERAL_ERROR, 'Could not get style information!', '', __LINE__, __FILE__, $sql);
}
		
$style_rowset = $db->sql_fetchrowset($result);

for($i = 0; $i < count($style_rowset); $i++)
{
	$id = $style_rowset[$i]['themes_id'];
	$sql = 'SELECT count(user_id) as total FROM ' . USERS_TABLE . ' WHERE user_style = ' . $id;
	$result = $db->sql_query($sql);
	if(!$result)
	{
		$total = 0;
	}
	else
	{
		$total = $db->sql_fetchrow($result);
		$total = $total['total'];
	}

	$template->assign_block_vars('styles', array(
		'STYLE'				=> $style_rowset[$i]['style_name'],
		'TEMPLATE'			=> $style_rowset[$i]['template_name'],
		'ID'				=> $id,
		'TOTAL'				=> $total
		)
	);
}

$template->assign_vars(array(
	'L_XS_STYLES_ID'				=> $lang['xs_styles_id'],
	'L_XS_STYLES_TEMPLATE'			=> $lang['xs_styles_template'],
	'L_XS_STYLES_STYLE'				=> $lang['xs_styles_style'],
	'L_XS_STYLES_USER'				=> $lang['xs_styles_user'],
	'L_XS_STYLES_OPTIONS'			=> $lang['xs_styles_options'],
	'L_XS_STYLES_SET_DEFAULT'		=> $lang['xs_styles_set_default'],
	'L_XS_STYLES_NO_OVERRIDE'		=> $lang['xs_styles_no_override'],
	'L_XS_STYLES_DO_OVERRIDE'		=> $lang['xs_styles_do_override'],
	'L_XS_STYLES_SWITCH_ALL'		=> $lang['xs_styles_switch_all'],
	'L_XS_STYLES_SWITCH_ALL2'		=> $lang['xs_styles_switch_all2'],
	'L_XS_STYLES_DEFSTYLE'			=> $lang['xs_styles_defstyle'],
	'L_XS_STYLES_AVAILABLE'			=> $lang['xs_styles_available'],
	'SCRIPT'						=> 'admin_xs_styles.' . $template->vars['PHP'],
	)
);

//
// show list of styles
// get number of users for every style
//
//  "set as default"
//  "switch all users to this style"
//  "set as default and switch all users"
//
//  "switch users to" ... "style"
//  "delete style" ("switch users to" ... [if usercount > 0]) 
//

$template->set_filenames(array('body' => 'admin/xs_styles_body.tpl'));
$template->pparse('body');
include('./page_footer_admin.'.$phpEx);


?>