<?php

//
// Start mod
//
if(!defined('IN_PHPBB'))
{
	define('IN_PHPBB', 1);
	$phpbb_root_path = "./../";
	require($phpbb_root_path . 'extension.inc');
	require('./pagestart.' . $phpEx);
}
else
{
	if( !empty($setmodules) )
	{
		$file = basename(__FILE__);
		$module['Extreme_Styles']['Updates'] = $file;
	}
}

//
// include language file
//

if(!defined('XS_LANG_INCLUDED'))
{
	$xs_lang_file = $phpbb_root_path . 'language/lang_' . $board_config['default_lang'] . '/lang_xs.'.$phpEx;
	if( !@file_exists($xs_lang_file) )
	{	// load english version if there is no translation to current language
		$xs_lang_file = $phpbb_root_path . 'language/lang_english/lang_xs.'.$phpEx;
	}
	@include($xs_lang_file);
	define('XS_LANG_INCLUDED', true);
}

//
// exit if mod was called just to set modules
//

if( !empty($setmodules) )
{
	return;
}

//
// constants
//

define('XS_UPDATE_STYLE', 1);
define('XS_UPDATE_MOD', 2);
define('XS_UPDATE_PHPBB', 3);

$updates = array();

function include_update($filename)
{
	$update = array();
	@include($filename);
	global $updates;
	$updates = array_merge($updates, $update);
}

if($dir = @opendir($phpbb_root_path. 'templates/'))
{
	while($sub_dir = @readdir($dir))
	if(($sub_dir !== '.') && ($sub_dir !== '..') && ($sub_dir !== 'CVS'))
	{
		$file = $phpbb_root_path . 'templates/' . $sub_dir . '/xs.cfg';
		if(@file_exists($file))
		{
			include_update($file);
		}
	}
}

// nothing to update
if(!count($updates))
{
	$template->set_filenames(array(
		'error' => 'error_body.tpl')
	);
	$template->assign_vars(array(
		'ERROR_MESSAGE' => $lang['xs_update_nothing'])
	);
	$template->pparse('error');
	include('./page_footer_admin.'.$phpEx);
	return;
}

// show list of available updates
if( !isset($HTTP_GET_VARS['doupdate']) )
{
	$template->set_filenames(array('body' => 'admin/xs_update_body.tpl'));
	$template->assign_vars(array(
		'MESSAGE_TITLE'			=> $lang['xs_update_title'],
		'UPDATE_URL'			=> append_sid('admin_xs_update.'.$phpEx.'?doupdate=1'),
		'L_XS_UPDATE_INFO1'		=> $lang['xs_update_info1'],
		'L_XS_UPDATE_TOTAL1'	=> sprintf($lang['xs_update_total1'], count($updates)),
		'L_XS_UPDATE_SELECT1'	=> $lang['xs_update_select1'],
		'L_XS_UPDATE_CURRENT_VERSION'	=> $lang['xs_update_current_version'],
		'L_XS_UPDATE_TYPE'		=> $lang['xs_update_type'],
		'L_XS_UPDATE_NAME'		=> $lang['xs_update_name'],
		'L_XS_CONTIUNE'			=> $lang['xs_update_continue'],
		'L_XS_UPDATE_TIMEOUT'	=> $lang['xs_update_timeout'],
		)
	);
	$counter = 0;
	@reset($updates);
	foreach($updates as $var => $item)
	{
		$counter ++;
		$type = isset($lang['xs_update_types'][$item['update_type']]) ? $item['update_type'] : 0;
		$template->assign_block_vars('row',
				array(
				'num'		=> $counter,
				'var'		=> 'item_'.$counter.'_',
				'item'		=> htmlspecialchars($var),
				'name'		=> htmlspecialchars($item['update_name']),
				'type'		=> $lang['xs_update_types'][$type],
				'url'		=> htmlspecialchars($item['update_url']),
				'version'	=> htmlspecialchars($item['update_version'])
				)
			);
	}
	$template->pparse('body');
	include('./page_footer_admin.'.$phpEx);
	return;
}

// check updates.

// getting list of items to update
@reset($updates);
$urls = array();
$items = array();
$i=0;
foreach($updates as $var1 => $item)
{
	$i++;
	$var = 'item_'.$i.'_';
	if(!empty($HTTP_POST_VARS[$var.'item']) && !empty($HTTP_POST_VARS[$var.'checked']) && $HTTP_POST_VARS[$var.'checked'])
	{
		$item = $HTTP_POST_VARS[$var.'item'];
		if(!empty($updates[$item]['update_url']))
		{
			$items[] = $var1;
			$found = false;
			$url = $updates[$item]['update_url'];
			for($j=0; $j<count($urls) && !$found; $j++)
			{
				if($urls[$j] === $url)
				{
					$found = true;
				}
			}
			if(!$found)
			{
				$urls[] = $url;
			}
		}
	}
	if(isset($updates[$var1]['data']))
	{
		unset($updates[$var1]['data']);
	}
}

// showing error message if there is nothing to update
if(!count($urls))
{
	$template->set_filenames(array(
		'error' => 'error_body.tpl')
	);
	$template->assign_vars(array(
		'ERROR_MESSAGE' => $lang['xs_update_nothing'])
	);
	$template->pparse('error');
	include('./page_footer_admin.'.$phpEx);
	return;
}

@set_time_limit(intval($HTTP_POST_VARS['timeout']));

// getting data
for($i=0; $i<count($urls); $i++)
{
	$arr = @file($urls[$i]);
	if(empty($arr))
	{
		// cannot connect. show it as error message
		@reset($items);
		for($j=0; $j<count($items); $j++)
		{
			$item = $updates[$items[$j]];
			if($item['update_url'] === $urls[$i])
			{
				$updates[$items[$j]]['data']['error'] = $lang['xs_update_error_noconnect'];
			}
		}
	}
	else
	{
		for($j=0; $j<count($arr); $j++)
		{	// trim all lines and replace tab with space
			$arr[$j] = trim(str_replace("\t", ' ', $arr[$j]));
		}
		// checking all items to see which ones are for this url
		for($j=0; $j<count($items); $j++)
		{
			$item = $updates[$items[$j]];
			if($item['update_url'] === $urls[$i])
			{
				// searching for data for this item
				$begin_text = '<!-- BEGIN ' . $item['update_item'] . ' -->';
				$end_text = '<!-- END ' . $item['update_item'] . ' -->';
				$begin_pos = -1;
				$end_pos = -1;
				// getting begin and end tags for it
				for($k=0; ($k<count($arr)-1) && ($begin_pos < 0); $k++)
				{
					if($arr[$k] === $begin_text)
					{
						$begin_pos = $k;
						for(; ($k<count($arr)) && ($end_pos < 0); $k++)
						{
							if($arr[$k] === $end_text)
							{
								$end_pos = $k;
							}
						}
						if($end_pos < 0)
						{
							$end_pos = count($arr);
						}
					}
				}
				$data = array();
				// found item position in text
				if($begin_pos >= 0)
				{
					// getting all data for this item in array
					for($k=$begin_pos+1; $k<$end_pos; $k++)
					{
						$arr2 = explode(' ', $arr[$k], 2);
						if(count($arr2) == 2)
						{
							$data[trim($arr2[0])] = trim($arr2[1]);
						}
					}
				}
				else
				{
					$data['error'] = $lang['xs_update_error_noitem'];
				}
				$updates[$items[$j]]['data'] = $data;
			}
		}
	}
}

$template->set_filenames(array('body' => 'admin/xs_update_body2.tpl'));

@reset($updates);
$count_total = 0;
$count_error = 0;
$count_update = 0;
foreach($updates as $var => $item)
{
	if(isset($item['data']) && is_array($item['data']))
	{
		$count_total++;
		$type = isset($lang['xs_update_types'][$item['update_type']]) ? $item['update_type'] : 0;
		$ver1 = htmlspecialchars($item['update_version']);
		$template->assign_block_vars('row',
			array(
				'item'			=> htmlspecialchars($item['update_name']),
				'type'			=> $lang['xs_update_types'][$type],
				'version'		=> $ver1,
			)
		);
		if(!empty($item['data']['version']))
		{
			$ver2 = htmlspecialchars($item['data']['version']);
			$info = isset($item['data']['info']) ? $item['data']['info'] : '';
			if($ver2 !== $ver1 && !empty($item['data']['update']))
			{
				$count_update++;
				$template->assign_block_vars('row.update',
					array(
						'version'		=> $ver2,
						'update'		=> htmlspecialchars($item['data']['update']),
						'info'			=> htmlspecialchars($info),
					)
				);
			}
			else
			{
				$template->assign_block_vars('row.noupdate', 
					array(
						'version'		=> $ver2,
						'message'		=> $lang['xs_update_noupdate'],
						'info'			=> htmlspecialchars($info),
					)
				);
			}
		}
		else
		{
			if(empty($item['data']['error']))
			{
				$item['data']['error'] = $lang['xs_update_error_noitem'];
			}
			$template->assign_block_vars('row.error', array('error' => htmlspecialchars($item['data']['error'])));
			$count_error++;
		}
	}
}

$template->assign_vars(
	array(
		'L_XS_UPDATE_TITLE'	=> $lang['xs_update_title'],
		'L_XS_DOWNLOAD'		=> $lang['xs_update_download'],
		'L_XS_INFO'			=> $lang['xs_update_info'],
		'L_XS_UPDATE_NAME'	=> $lang['xs_update_name'],
		'L_XS_UPDATE_TYPE'	=> $lang['xs_update_type'],
		'L_XS_UPDATE_CURRENT_VERSION'	=> $lang['xs_update_current_version'],
		'L_XS_UPDATE_LATEST_VERSION'	=> $lang['xs_update_latest_version'],
		'L_XS_UPDATE_DOWNLOADINFO'	=> $lang['xs_update_downloadinfo'],
		'L_XS_UPDATE_FILEINFO'		=> $lang['xs_update_fileinfo'],
		'COUNT_TOTAL'		=> sprintf($lang['xs_update_total1'], $count_total),
		'COUNT_ERROR'		=> sprintf($lang['xs_update_total2'], $count_error),
		'COUNT_UPDATE'		=> sprintf($lang['xs_update_total3'], $count_update)
	)
);

$template->pparse('body');
include('./page_footer_admin.'.$phpEx);


?>